/* AMX Mod script. 
* 
* (c) 2001-2015, OLO shadow
* Custom modified by TjaardA
* This file is provided as is (no warranties). 
* 
* Players with immunity won't be checked 
*/ 

#include <amxmodx> 
#include <amxmisc>

new g_Ping[33]
new g_Samples[33]

public plugin_init()
{
  register_plugin("High Ping Kicker","v2.0","TjaardA-Powered")
  register_concmd("amx_hpk","cmdHpk",ADMIN_KICK,"- configures high_ping_kicker_v2 plugin")
  register_cvar("amx_hpk_ping","100")
  register_cvar("amx_hpk_check","17")
  register_cvar("amx_hpk_tests","3")
  register_cvar("amx_hpk_delay","10")
  register_cvar("amx_hpk_peak","111") 
  
  if ( get_cvar_num( "amx_hpk_check" ) < 16 ) set_cvar_num( "amx_hpk_check" , 16 )
  if ( get_cvar_num( "amx_hpk_tests" ) < 2 ) set_cvar_num( "amx_hpk_tests" , 2 )
}

public client_disconnect(id) 
  remove_task( id )

public client_putinserver(id) 
{    
  g_Ping[id] = 0 
  g_Samples[id] = 0

  if ( !is_user_bot(id) ) 
  {
    new param[1]
    param[0] = id 
    set_task( 10.0 , "showWarn" , id , param , 1 )
    
    if (get_cvar_num("amx_hpk_tests") != 0) {
	    set_task( float(get_cvar_num("amx_hpk_delay")), "taskSetting", id, param , 1)
    }
    else {	    
    	set_task( float(get_cvar_num( "amx_hpk_tests" )) , "checkPing" , id , param , 1 , "b" )
	}
	
  }
} 

public showWarn(param[])
  client_print( param[0] ,print_chat,"* Max Player Latency %d !", get_cvar_num( "amx_hpk_ping" ) )

public taskSetting(param[]) {
	new name[32]
	get_user_name(param[0],name,31)
	set_task( float(get_cvar_num( "amx_hpk_tests" )) , "checkPing" , param[0] , param , 1 , "b" )
}

kickPlayer( id ) 
{ 
	new name[32],authid[32]
	get_user_name(id,name,31)
	get_user_authid(id,authid,31)

  	client_print(0,print_chat,"** Kicked %s for High Latency.....",name)
	client_cmd(id,"echo ^"** Ping to high, Fix Your Latency.....^";disconnect")
	remove_task(id)
} 

public checkPing(param[]) 
{ 
  new id = param[ 0 ] 

  new p, l 

  get_user_ping( id , p , l ) 

  g_Ping[ id ] += p
  ++g_Samples[ id ]

  if ( (g_Ping[id] / g_Samples[id] > get_cvar_num( "amx_hpk_peak" ))  ) // peak pingers kick zonder hpk tests     
    kickPlayer(id) 

  else if ( (g_Samples[ id ] > get_cvar_num( "amx_hpk_tests" )) && (g_Ping[id] / g_Samples[id] > get_cvar_num( "amx_hpk_ping" ))  )    
    kickPlayer(id) 
  
}

  
public cmdHpk(id,level,cid){
  if (!cmd_access(id,level,cid,1))
    return PLUGIN_HANDLED
    
  new ping_arr[5]
  new check_arr[5]
  new tests_arr[5]
  new delay_arr[5]
  new peak_arr[5]

  read_argv(1,ping_arr,4)
  read_argv(2,check_arr,4)
  read_argv(3,tests_arr,4)
  read_argv(4,delay_arr,4)
  read_argv(5,peak_arr,4)

  new ping = str_to_num(ping_arr)
  new check = str_to_num(check_arr)
  new tests = str_to_num(tests_arr)
  new delay = str_to_num(delay_arr)
  new peak = str_to_num(peak_arr)
  
  if ( check < 16 ) check = 16
  if ( tests < 2 ) tests = 2
  if ( peak < ping ) peak = ping 

  if (read_argc() > 1){
    	set_cvar_num("amx_hpk_ping",ping)
  }
  if (read_argc() > 2) {
	set_cvar_num("amx_hpk_check",check)
  }
  if (read_argc() > 3) {
	set_cvar_num("amx_hpk_tests",tests)
  }
  if (read_argc() > 4) {
	set_cvar_num("amx_hpk_delay",delay)
  }
  if (read_argc() > 5) {
	set_cvar_num("amx_hpk_peak",peak)
 }

  console_print(id,"Syntax: amx_hpk <ping to get kicked> <checks before kicks> <time between checks> <delay before first check in sec.> <peak ping value>")
  console_print(id,"Current High_Ping_Kicker Settings:")
  console_print(id,"Maxping: %d  Time between checks: %d Checkcount: %d Delay: %d peak: %d",get_cvar_num("amx_hpk_ping"),get_cvar_num("amx_hpk_check"),get_cvar_num("amx_hpk_tests"),get_cvar_num("amx_hpk_delay"),get_cvar_num("amx_hpk_peak"))
  return PLUGIN_HANDLED    
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang2067\\ f0\\ fs16 \n\\ par }
*/
